Index: orxonox/branches/levelloader/src/lib/util/list.h
===================================================================
--- orxonox/branches/levelloader/src/lib/util/list.h	(revision 3604)
+++ orxonox/branches/levelloader/src/lib/util/list.h	(revision 3605)
@@ -86,4 +86,5 @@
   T* enumerate();
   T* nextElement();
+  T* nextElement(T* toEntity);
   T* toArray();
   void debug();
@@ -101,9 +102,23 @@
 template<class T>
 tList<T>::~tList () 
-{}
+{
+  this->currentEl = this->first;
+  while(this->currentEl != NULL)
+    {
+      listElement* le = this->currentEl->next;
+      //delete this->currentEl->curr;
+      delete this->currentEl;
+      this->currentEl = le;
+    }
+  this->first = NULL;
+  this->last = NULL;
+  this->size = 0;
+}
+
 
 template<class T>
 void tList<T>::add(T* entity)
 {
+  if( entity == NULL) return;
   listElement* el = new listElement;
   el->prev = this->last;
@@ -113,5 +128,5 @@
   this->last = el;
 
-  if(this->size == 0) this->first = el;
+  if(el->prev == NULL) this->first = el; /* if first element */
   else el->prev->next = el;
   this->size++;
@@ -122,4 +137,5 @@
 void tList<T>::remove(T* entity)
 {
+  if( entity == NULL) return;
   this->currentEl = this->first;
   listElement* te;
@@ -134,7 +150,8 @@
 	  else this->currentEl->next->prev = this->currentEl->prev;
 
-	  te = this->currentEl->next;
+	  te = this->currentEl->next;  // for what am i doing this?
 	  delete this->currentEl;
 	  this->currentEl = te;
+	  this->size--;
 	  return;
 	}
@@ -151,5 +168,5 @@
     {
       listElement* le = this->currentEl->next;
-      delete this->currentEl->curr;
+      //delete this->currentEl->curr;
       delete this->currentEl;
       this->currentEl = le;
@@ -185,4 +202,5 @@
 T* tList<T>::enumerate()
 {
+  //if( this->last == this->first == NULL) return NULL;
   if(this->size == 0) return NULL;
   this->currentEl = this->first;
@@ -194,4 +212,5 @@
 T* tList<T>::nextElement()
 {
+  // if( this->last == this->first == NULL) return NULL;
   if(this->size == 0) return NULL;
   this->currentEl = this->currentEl->next;
@@ -201,4 +220,24 @@
 
 
+/**
+   \brief this returns the next element after toEntity or the first if toEntity is last
+*/
+template<class T>
+T* tList<T>::nextElement(T* toEntity)
+{
+  //if( this->last == this->first == NULL) return NULL;
+  if(this->size == 0) return NULL;
+  if( toEntity == NULL) return this->first->curr;
+  if( toEntity == this->last->curr ) return this->first->curr;
+  this->currentEl = this->first;
+  while(this->currentEl->curr != toEntity && this->currentEl->next != NULL)
+    {
+      this->currentEl = this->currentEl->next;
+    }
+  if(this->currentEl == NULL) return NULL;
+  return this->currentEl->next->curr;
+}
+
+
 template<class T>
 T* tList<T>::toArray()
Index: orxonox/branches/levelloader/src/orxonox.cc
===================================================================
--- orxonox/branches/levelloader/src/orxonox.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/orxonox.cc	(revision 3605)
@@ -31,5 +31,5 @@
 #include "game_loader.h"
 #include <string.h>
-int verbose;
+int verbose = 4;
 
 using namespace std;
@@ -54,5 +54,4 @@
   if( resources != NULL) delete resources;
 }
-
 
 /** \brief this is a singleton class to prevent duplicates */
@@ -173,8 +172,4 @@
   // SDL_WM_SetIcon(SDL_Surface *icon, Uint8 *mask);  
 
-  // OpenGL stuff
-  glClearColor (0.0, 0.0, 0.0, 0.0);
-  glEnable (GL_DEPTH_TEST);
-   
   return 0;
 }
Index: orxonox/branches/levelloader/src/orxonox.conf
===================================================================
--- orxonox/branches/levelloader/src/orxonox.conf	(revision 3604)
+++ orxonox/branches/levelloader/src/orxonox.conf	(revision 3605)
@@ -5,4 +5,5 @@
 RIGHT=right
 SPACE=fire
+m=mode
 ESCAPE=quit
 p=pause
@@ -10,5 +11,4 @@
 BUTTON_LEFT=fire
 BUTTON_RIGHT=altfire
-b=benscho
 x=up_world
 z=down_world
Index: orxonox/branches/levelloader/src/orxonox.h
===================================================================
--- orxonox/branches/levelloader/src/orxonox.h	(revision 3604)
+++ orxonox/branches/levelloader/src/orxonox.h	(revision 3605)
@@ -24,6 +24,6 @@
   static Orxonox* singletonRef;
   Orxonox ();
-  ~Orxonox ();
-  
+  virtual ~Orxonox ();
+
   char configfilename[256];   //!< Filename of the configuration-file.
   World* world;               //!< Reference to the current running world.
Index: orxonox/branches/levelloader/src/proto_class.cc
===================================================================
--- orxonox/branches/levelloader/src/proto_class.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/proto_class.cc	(revision 3605)
@@ -16,7 +16,9 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
 
 #include "proto_class.h"
 
+#include "stdincl.h" // maybe
 
 using namespace std;
@@ -35,9 +37,10 @@
 /**
    \brief standard deconstructor
-   \todo this deconstructor is not jet implemented - do it
 
 */
-ProtoClass::~ProtoClass () {}
-
+ProtoClass::~ProtoClass () 
+{
+  // delete what has to be deleted here
+}
 
 /**
Index: orxonox/branches/levelloader/src/proto_class.h
===================================================================
--- orxonox/branches/levelloader/src/proto_class.h	(revision 3604)
+++ orxonox/branches/levelloader/src/proto_class.h	(revision 3605)
@@ -11,5 +11,10 @@
 #define _PROTO_CLASS_H
 
-#include "stdincl.h"
+#include "what realy has to be included"
+#include "base_object.h"
+
+// FORWARD DEFINITION \\
+class someClassWeNeed;
+
 
 /*class Test;*/ /* forward definition of class Test (without including it here!)*/
@@ -22,6 +27,6 @@
 
  public:
-  ProtoClass ();
-  ~ProtoClass ();
+  ProtoClass();
+  virtual ~ProtoClass();
 
   bool doNonSense (int nothing);
Index: orxonox/branches/levelloader/src/simple_animation.cc
===================================================================
--- orxonox/branches/levelloader/src/simple_animation.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/simple_animation.cc	(revision 3605)
@@ -0,0 +1,229 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+
+#include "simple_animation.h"
+#include "stdincl.h"
+#include "p_node.h"
+
+using namespace std;
+
+/**
+   \brief standard constructor
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+*/
+KeyFrame::KeyFrame(Vector* point, Quaternion* orientation, float time)
+{
+  this->setRelCoor(point);
+  this->setRelDir(orientation);
+  this->time = time;
+}
+
+
+/**
+   \brief standard constructor
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+   \param function of the velocity of the movement 
+*/
+KeyFrame::KeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode)
+{
+  this->setRelCoor(point);
+  this->setRelDir(orientation);
+  this->time = time;
+  this->mode = mode;
+}
+
+
+/**
+   \brief standard deconstructor
+*/
+KeyFrame::~KeyFrame()
+{
+}
+
+
+/**
+   \brief sets the important properties of a Keyframe
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+*/
+void KeyFrame::set(Vector* point, Quaternion* orientation, float time)
+{
+  this->setRelCoor(point);
+  this->setRelDir(orientation);
+  this->time = time;
+}
+
+
+/**
+   \brief sets the important properties of a Keyframe
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+   \param function of the velocity of the movement 
+*/
+void KeyFrame::set(Vector* point, Quaternion* orientation, float time, movementMode mode)
+{
+  this->setRelCoor(point);
+  this->setRelDir(orientation);
+  this->time = time;
+  this->mode = mode;
+}
+
+
+
+/**
+   \brief standard constructor
+*/
+SimpleAnimation::SimpleAnimation (PNode* parent) 
+{
+   this->setClassName ("SimpleAnimation");
+   this->frames = new tList<KeyFrame>();
+   this->localTime = 0;
+   this->bPause = false;
+   this->parent = parent;
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+SimpleAnimation::~SimpleAnimation () 
+{
+  KeyFrame* frame = this->frames->enumerate(); 
+  while( frame != NULL) 
+    { 
+      delete frame;
+      frame = frames->nextElement();
+    }
+  delete this->frames;
+}
+
+
+
+/**
+   \brief adds a keyframe with properties
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+*/
+void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* orientation, float time)
+{
+  KeyFrame* frame = new KeyFrame(point, orientation, time);
+  this->frames->add(frame);
+}
+
+
+/**
+   \brief adds a keyframe with properties
+   \param the point of the object
+   \param and the orientation of it
+   \param at this time
+   \param function of the velocity of the movement 
+*/
+void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode)
+{
+  KeyFrame* frame = new KeyFrame(point, orientation, time, mode);
+  this->frames->add(frame);
+}
+
+/**
+   \brief adds a already defined keyframe
+   \param the keyframe to add
+*/
+void SimpleAnimation::addKeyFrame(KeyFrame* frame)
+{
+  this->frames->add(frame);
+}
+
+
+/**
+   \brief clear the list of keyframes, deleting all keyframes included
+*/
+void SimpleAnimation::reset()
+{
+  KeyFrame* frame = this->frames->enumerate(); 
+  while( frame != NULL) 
+    { 
+      delete frame;
+      frame = frames->nextElement();
+    }
+  delete this->frames;
+
+  this->frames = new tList<KeyFrame>();
+  this->localTime = 0;
+  this->bPause = false;
+
+}
+
+/**
+   \brief starts the animation, therefore listens to tick signals
+*/
+void SimpleAnimation::start()
+{}
+
+
+/**
+   \brief stops the animation, immune to tick signals
+*/
+void SimpleAnimation::stop()
+{}
+
+/**
+   \brief stops and then starts the animation from begining
+*/
+void SimpleAnimation::restart()
+{
+  this->localTime = 0;
+  this->bPause = false;
+}
+
+/**
+   \brief pauses the animation until resumed
+*/
+void SimpleAnimation::pause()
+{
+  this->bPause = true;
+}
+
+/**
+   \brief resumes a pause, if not paused, no effect
+*/
+void SimpleAnimation::resume()
+{
+  this->bPause = false;
+}
+
+
+/**
+   \brief heart beat, next animation step
+*/
+void SimpleAnimation::tick(float time)
+{
+  if(!this->bPause)
+    {
+
+
+
+    }
+}
Index: orxonox/branches/levelloader/src/simple_animation.h
===================================================================
--- orxonox/branches/levelloader/src/simple_animation.h	(revision 3605)
+++ orxonox/branches/levelloader/src/simple_animation.h	(revision 3605)
@@ -0,0 +1,72 @@
+/*! 
+    \file simple_animation.h
+    \brief A class to interpolate the movement of an object following descrete points in room and time
+    \todo implement it
+
+    This class has been done to animate some movement, works best for short 
+    distances.
+*/
+
+#ifndef _SIMPLE_ANIMATION_H
+#define _SIMPLE_ANIMATION_H
+
+#include "base_object.h"
+#include "p_node.h"
+#include "list.h"
+
+
+typedef enum movementMode{LINEAR=0, EXP, NEG_EXP, SIN, COS};
+
+
+//! KeyFrame Class
+/**
+   This represents one point with orientation of the animation
+*/
+class KeyFrame : public PNode {
+ public:
+  KeyFrame(Vector* point, Quaternion* orientation, float time);
+  KeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode); 
+  virtual ~KeyFrame();
+
+  void set(Vector* point, Quaternion* orientation, float time);
+  void set(Vector* point, Quaternion* orientation, float time, movementMode mode);
+  
+ private:
+  float time;
+  movementMode mode;
+};
+
+
+//! Animation Class
+/**
+   Helps you making some small animation
+*/
+class SimpleAnimation : public BaseObject {
+  
+ public:
+  SimpleAnimation(PNode* parent);
+  virtual ~SimpleAnimation();
+
+  void addKeyFrame(Vector* point, Quaternion* orientation, float time);
+  void addKeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode);
+  void addKeyFrame(KeyFrame* frame);
+  void reset();
+
+  void start();
+  void stop();
+  void restart();
+  void pause();
+  void resume();
+
+  void tick(float time);
+
+ private:
+  bool bPause;                     //<! is set, when there is a pause
+  tList<KeyFrame>* frames;        //<! where keyframes are stored in
+  float localTime;
+  PNode* parent;
+  
+
+};
+
+#endif /* _SIMPLE_ANIMATION_H */
Index: orxonox/branches/levelloader/src/story_entities/campaign.h
===================================================================
--- orxonox/branches/levelloader/src/story_entities/campaign.h	(revision 3604)
+++ orxonox/branches/levelloader/src/story_entities/campaign.h	(revision 3605)
@@ -14,5 +14,5 @@
   Campaign ();
   Campaign ( TiXmlElement* root);
-  ~Campaign ();
+  virtual ~Campaign ();
 
   StoryEntity* currentEntity;
